<?php
# ---------------------------------------------------------------------------------

/**
* @version v 2.0 for Joomla! 1.5.x
* @author: Gero Zahn, gero@gerozahn.de, http://www.gerozahn.de/bot_gzFlashEmbed/
* @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.*/

/*

	NOTE:

		This is a legacy implementation of the gzflashembedsearch mambot - i.e.
		not much more than the original mambot tuned up to Joomla! 1.5.

		As this "registerEvent(...)" implementation will become deprecated
		sooner or later, there will of course be a true, more efficient
		"class plgSearchGzFlashEmbed extends JPlugin" implementation.

		But sorry - not today ...

*/

# ---------------------------------------------------------------------------------

// Check to ensure this file is included in Joomla!
defined( '_JEXEC' ) or die( 'Restricted access' );

$mainframe->registerEvent( 'onSearch', 'botSearchgzFlashEmbed' );

# ---------------------------------------------------------------------------------

/**
* gzFlashEmbed Search method
*
* The sql must return the following fields that are used in a common display
* routine: href, title, section, created, text, browsernav
* @param string Target search string
* @param string mathcing option, exact|any|all
* @param string ordering option, newest|oldest|popular|alpha|category
*/
function botSearchgzFlashEmbed( $text, $phrase='', $ordering='' ) {

	if (function_exists("plgSearchContent")) {

#		echo "$text - $phrase - $ordering<br />\n";

		$db =& JFactory::getDBO();

		# Strategy: We'll first search in our Flash text cache to find out in which
		# indexed Flash text the search term can be found.
		# Afterwards we'll ask the regular content filter for those contents in which
		# the found Flash clips are embedded.

		# Let's get going and search for the Flash words.

		$text=htmlentities(utf8_decode($text)); # Make sure to find HTML entities

		switch ($phrase) { # The usual - exact, all, any
			case 'exact':
				$where 		= "(LOWER(a.swftext) LIKE '%$text%')";
				break;
			
			case 'all':
			case 'any':
			default:
				$words = explode( " ", $text );
				$wheres = array();
				foreach ($words as $word) {
					$wheres[] 	= "(LOWER(a.swftext) LIKE '%$word%')";
				}
				$where = "(" . implode( ($phrase == "all" ? ") AND (" : ") OR ("), $wheres ) . ")";
				break;
		}

		$sql="SELECT swffilename FROM #__gzflashembed AS a WHERE $where"; # Get the Flash file names

		$db->setQuery($sql);
		$rows = $db->loadObjectList();

		$words=array(); # Each SWF file will be a "word" now to be searched in the content elements
		foreach($rows as $row) {
			$words[]=$row->swffilename;
		}
		$words=implode(" ",$words);

		# Now "shell out" these results into the regular content search ... if possible
		return plgSearchContent( $words, $any, $ordering );

		# ... Woah, this is it? Yes it is - as of Joomla 1.5.7 Production/Stable [ Wovusani ]
		# 
		# As soon as as Open Source Matters will re-implement the content search (ie. content.php)
		# as "class plgSearchContent extends JPlugin", I have to come up with a better way to
		# "spawn" this child-search. ... I'll face this when it's necessary.

	} else { # plgSearchContent non-existent - content search is disabled
		return array();
	}

}

# ---------------------------------------------------------------------------------

?>